'Mentor Graphics PADS basic SCRIPT.
'Excel Pick & Place (Centroid) File.bas. Units in mm. Sep 17 2015 by Beepster.
'Requires MS Excel.

'This script should be located; C:\MentorGraphics\9.5PADS\SDD_HOME\Samples\Scripts\Layout
'Then needs to be loaded (one time); Pads Layout, Tools, Basic Scripts.  Alt-t a s 

'Made from; Sample 17: Excel Part List Report.BAS
'It will create reports in Microsoft Excel.

' A parts Value is passed from Orcad schematic to Pads as an Attribute using Chuck T's Orcad-to-Pads netlister, PowerNET.exe

' Pick & Place Fiducials should have a Footprint whos name starts, FID     Example: FIDUCIAL3015

' These part Values are treated as non-parts;
' HOLE..., ...HOLE, SOLDER_PAD, TP, TEST_POINT, DRIL..., SLOT, MH, VIA, PAD

' No populate / do not install; part values start or end DNI or DNP. Examples  10K,DNP or DNI_10K

' Bottom parts have a minus-X axis value as per standard P&P files.
' X & Y locations are Part-Origin to PCB Origin.

' Rotated to a not 90-deg rotation;
' PADS "CAM PLUS" reports, in a log file, "Unsupported rotation angle, part skipped"   Skipped !!!!!!
' Not a problem with this Script.

' Fills windows clipboard with file path & name for "Excel, Save As".  Cntrl-v to paste.

' Credit to; Hannu Tikkanen for function to test SMD by drill size of pin 1. Fixes problem with SMDs having drilled thermal pad.
'-----------------------------------------------------------------------------------------------------------

  Public Color1, Color2, Color3, Color4, Color5, Color6, Color7, Color8, Color9, Color10, Color11
  Const Columns = Array("Item#", "RefDes", "PartDecal", "PartValue", "X-mm", "Y-mm", "Orient.", "Layer", "SMD")

Sub Main
	LockServer ' Lock server to speed up process
  ' MsgBox "This will take some time. Fidutials should have a part VALUE of FIDxxx. Holes should have a VALUE of MH, HOLExxx, xxxHOLE."
	L1NAME = ActiveDocument.LayerName(1) 'Name of top layer
	
	currentUnit = ActiveDocument.unit
	ActiveDocument.unit = 4 ' Set units to mm
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile For Output As #1
	On Error Resume Next

'Output title
  OutCell "Pick & Place (Centroid) file"
  Outcell ""
  Outcell ""
  Outcell "Based on a components origin (0,0 location)"
  Outcell ""
  Outcell ""
  Outcell ""
  Outcell ""
  Outcell ""
  Outcell "A parts Value is passed from Orcad schematic to Pads as an Attribute using Chuck T's Orcad-to-Pads netlister, PowerNET.exe"
  Print #1
  Linenum = Linenum + 1
  filename = "PCB file, " & ActiveDocument
  Outcell filename
  Outcell ""
  Outcell ""
  Outcell "Script by Beepster, the Great & Powerfull!"
   
  Print #1
  Linenum = Linenum + 1
  Today = Date()
  Outcell Today
  Print #1
  Linenum = Linenum + 1
  Print #1
  Linenum = Linenum + 1

  'Output table header
  For i = 0 To UBound(Columns)
  OutCell Columns(i)
  Next
  Print #1
  Linenum = Linenum + 1

'Check Attribute "Value" and count parts
  For Each part In ActiveDocument.Components
 '***** If part.Attributes("Value") Is Nothing Then part.Attributes.Add("Value","") 'This line add attribute "Value" if missing, No longer used!!
  Nparts = Nparts + 1
  Next part
  If Nparts > 199 Then MsgBox "This will take some time. #Parts " & Nparts
	
'Top Fiducials
  For Each part In ActiveDocument.Components
  If ActiveDocument.LayerName(part.layer) <> L1NAME Then GoTo SkipF
		
  ' Non Parts, 
  If UCase(Left(part.Decal, 3)) <> "FID" Then GoTo SkipF
  If HeaderTF = 1 Then GoTo ShTF
  Outcell "**** Top Pick & Place Fiducials. ( No Part )"
  Print #1
  Linenum = Linenum + 1
  HeaderTF = 1
  Color1 = Linenum
ShTF:
  OutCell "-"
  OutCell part.Name
  OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell "0"                                   ' Fiducials are reported zero rotation.
  OutCell ActiveDocument.LayerName(part.layer)
  OutCell ""
  Print #1
  Linenum = Linenum + 1
SkipF:
  Next part

'Output, Bottom Fiducials
  For Each part In ActiveDocument.Components
  If ActiveDocument.LayerName(part.layer) = L1NAME Then GoTo SkipBF

  ' Non Parts, 
  If UCase(Left(part.Decal, 3)) <> "FID" Then GoTo SkipBF
  If HeaderBF = 1 Then GoTo ShBF
  Outcell "**** Bottom Pick & Place Fiducials"
  Print #1
  Linenum = Linenum + 1
  HeaderBF = 1
  Color2 = Linenum
ShBF:
  OutCell "-"
  OutCell part.Name
  OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX*-1, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell "0"
  OutCell ActiveDocument.LayerName(part.layer)
  OutCell ""
  Print #1
  Linenum = Linenum + 1
SkipBF:
  Next part
	
  If HeaderTF Or HeaderBF = 1 Then 
  Print #1 
  Linenum = Linenum + 1
  End If
'---------------------
	
	'Output, Top SMD parts
	For Each part In ActiveDocument.Components
  If ActiveDocument.LayerName(part.layer) <> L1NAME Then GoTo Skip
	' Non Parts, 
	If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Skip
	If UCase(Left(part.Decal, 3)) = "FID" Then GoTo Skip
	If UCase(Left(part.Attributes("Value"), 4)) = "HOLE" Or UCase(Right(part.Attributes("Value"), 4)) = "HOLE"  Then GoTo Skip ' Hole
	If UCase(Left(part.Attributes("Value"), 2)) = "MH" Then GoTo Skip
	If UCase(Left(part.Decal, 2)) = "TP" Or UCase(part.Attributes("Value")) = "TP" Then GoTo Skip
	If part.Attributes("Value") = "TEST_POINT" Then GoTo Skip
	If UCase(Left(part.Decal, 4)) = "DRIL" Then GoTo Skip
	If part.Attributes("Value") = "SLOT" Then GoTo Skip
	If UCase(Left(part.Decal, 6)) = "SOLDER" Then GoTo Skip
	If UCase(Left(part.Decal, 3)) = "VIA" Then GoTo Skip
	If UCase(Left(part.Decal, 3)) = "PAD" Or UCase(Left(part.Decal, 3)) = "MTG" Then GoTo Skip
	
'	If part.IsSMD = False Then GoTo Skip     'Layout's own property - looks for any pin drill
    a = Format(IsSMDByPin1(part), "Yes/No")  'Custom function - looks pin 1 drill size
    If a = "No" Then GoTo Skip
    Item = Item + 1
	If Header1 = 1 Then GoTo Sh1
	Outcell "**** Top SMD"
    Print #1
    Linenum = Linenum + 1
    Header1 = 1
    Color3 = Linenum
Sh1:
  OutCell Item
  OutCell part.Name
  OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
  OutCell ActiveDocument.LayerName(part.layer)
  'OutCell Format(part.IsSMD, "Yes/No")
  b = Format(part.IsSMD, "Yes/No")
  If a = "Yes" And b = "Yes" Then OutCell "Yes" Else OutCell "????"
  Print #1
  Linenum = Linenum + 1
Skip:
  Next part
'Bottom SMD parts
  For Each part In ActiveDocument.Components
	If ActiveDocument.LayerName(part.layer) = L1NAME Then GoTo Skip2
	' Non Parts, 
	If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Skip2
	If UCase(Left(part.Decal, 3)) = "FID" Then GoTo Skip2
	If UCase(Left(part.Attributes("Value"), 4)) = "HOLE" Or UCase(Right(part.Attributes("Value"), 4)) = "HOLE"  Then GoTo Skip2 
	If UCase(Left(part.Attributes("Value"), 2)) = "MH" Then GoTo Skip2
	If UCase(Left(part.Decal, 1)) = "#" Then GoTo Skip2  ' Mounting Hole
	If UCase(Left(part.Decal, 2)) = "TP" Or UCase(part.Attributes("Value")) = "TP" Then GoTo Skip2
	If part.Attributes("Value") = "TEST_POINT" Then GoTo Skip2
	If UCase(Left(part.Decal, 4)) = "DRIL" Then GoTo Skip2
	If part.Attributes("Value") = "SLOT" Then GoTo Skip2
	If UCase(Left(part.Decal, 6)) = "SOLDER" Then GoTo Skip2
	If UCase(Left(part.Decal, 3)) = "VIA" Then GoTo Skip2
	If UCase(Left(part.Decal, 3)) = "PAD" Or UCase(Left(part.Decal, 3)) = "MTG" Then GoTo Skip2
	'	If part.IsSMD = False Then GoTo Skip2
	a = Format(IsSMDByPin1(part), "Yes/No")  'Custom function - looks pin 1 drill size
  If a = "No" Then GoTo Skip2
	
	Item = Item + 1
	If Header2 = 1 Then GoTo Sh2
	Outcell "**** Bottom SMD"
  Print #1
  Linenum = Linenum + 1
  Header2 = 1
  Color4 = Linenum
Sh2:
	OutCell Item
	OutCell part.Name
	OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX*-1, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
	OutCell ActiveDocument.LayerName(part.layer)
  'OutCell Format(part.IsSMD, "Yes/No")
   b = Format(part.IsSMD, "Yes/No")
   If a = "Yes" And b = "Yes" Then OutCell "Yes" Else OutCell "????"
	 Print #1
	 Linenum = Linenum + 1
Skip2:
	 Next part
'---------------------				
	'Top Through Hole
	For Each part In ActiveDocument.Components
  If ActiveDocument.LayerName(part.layer) <> L1NAME Then GoTo Skip3

  a = Format(IsSMDByPin1(part), "Yes/No")  'Custom function - looks pin 1 drill size
  If a = "Yes" Then GoTo Skip3
    
	' Non Parts, 
	If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Skip3
	If UCase(Left(part.Decal, 3)) = "FID" Then GoTo Skip3
  If UCase(Left(part.Attributes("Value"), 4)) = "HOLE" Or UCase(Right(part.Attributes("Value"), 4)) = "HOLE" Then GoTo Skip3 
	If UCase(Left(part.Attributes("Value"), 2)) = "MH" Then GoTo Skip3
	If UCase(Left(part.Decal, 1)) = "#" Then GoTo Skip3  ' Mounting Hole
	If UCase(Left(part.Decal, 2)) = "TP" Or UCase(part.Attributes("Value")) = "TP" Then GoTo Skip3
	If part.Attributes("Value") = "TEST_POINT" Then GoTo Skip3
	If UCase(Left(part.Decal, 4)) = "DRIL" Then GoTo Skip3
	If part.Attributes("Value") = "SLOT" Then GoTo Skip3
	If UCase(Left(part.Decal, 6)) = "SOLDER" Then GoTo Skip3
	If UCase(Left(part.Decal, 3)) = "VIA" Then GoTo Skip3
	If UCase(Left(part.Decal, 3)) = "PAD" Or UCase(Left(part.Decal, 3)) = "MTG" Then GoTo Skip3
	Item = Item + 1
	If Header3 = 1 Then GoTo Sh3
	Outcell "**** Top Through Hole"
  Print #1
  Linenum = Linenum + 1
  Header3 = 1
  Color5 = Linenum
Sh3:
	OutCell Item
	OutCell part.Name
	OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
	OutCell ActiveDocument.LayerName(part.layer)
	OutCell Format(part.IsSMD, "Yes/No")
  Print #1
	Linenum = Linenum + 1
Skip3:
	Next part
'---------------------	
	'Bottom Through Hole
	For Each part In ActiveDocument.Components
	If ActiveDocument.LayerName(part.layer) = L1NAME Then GoTo Skip4
	
	' Non Parts, 
	If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Skip4
	If UCase(Left(part.Decal, 3)) = "FID" Then GoTo Skip4
	If UCase(Left(part.Attributes("Value"), 4)) = "HOLE" Or UCase(Right(part.Attributes("Value"), 4)) = "HOLE" Then GoTo Skip4 
	If UCase(Left(part.Attributes("Value"), 2)) = "MH" Then GoTo Skip4
	If UCase(Left(part.Decal, 1)) = "#" Then GoTo Skip4  ' Mounting Hole
	If UCase(Left(part.Decal, 2)) = "TP" Or UCase(part.Attributes("Value")) = "TP" Then GoTo Skip4
	If part.Attributes("Value") = "TEST_POINT" Then GoTo Skip4
	If UCase(Left(part.Decal, 4)) = "DRIL" Then GoTo Skip4
	If part.Attributes("Value") = "SLOT" Then GoTo Skip4
	If UCase(Left(part.Decal, 6)) = "SOLDER" Then GoTo Skip4
	If UCase(Left(part.Decal, 3)) = "VIA" Then GoTo Skip4
	If UCase(Left(part.Decal, 3)) = "PAD" Or UCase(Left(part.Decal, 3)) = "MTG" Then GoTo Skip4

  'If part.IsSMD Then GoTo Skip4
  a = Format(IsSMDByPin1(part), "Yes/No")  'Custom function - looks pin 1 drill size
  If a = "Yes" Then GoTo Skip4
  Item = Item + 1
	If Header4 = 1 Then GoTo Sh4
	Outcell "**** Bottom Through Hole"
  Print #1
  Linenum = Linenum + 1
  Header4 = 1
  Color6 = Linenum
Sh4:
	OutCell Item
	OutCell part.Name
	OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX*-1, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
	OutCell ActiveDocument.LayerName(part.layer)
	OutCell Format(part.IsSMD, "Yes/No")
	Print #1
	Linenum = Linenum + 1
Skip4:
	Next part
'---------------------		
	'Top Holes, TP, 
	For Each part In ActiveDocument.Components
	If ActiveDocument.LayerName(part.layer) <> L1NAME Then GoTo Skip5
	If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Skip5
	If UCase(Left(part.Decal, 3)) = "FID" Then GoTo Skip5
	If UCase(Left(part.Attributes("Value"), 4)) = "HOLE" Or UCase(Right(part.Attributes("Value"), 4)) = "HOLE" Then GoTo Noskip
	If UCase(Left(part.Attributes("Value"), 2)) = "MH" Then GoTo Noskip
	If UCase(Left(part.Decal, 1)) = "#" Then GoTo Noskip  ' Mounting Hole
	If UCase(Left(part.Decal, 2)) = "TP" Or UCase(part.Attributes("Value")) = "TP" Then GoTo Noskip
	If part.Attributes("Value") = "TEST_POINT" Then GoTo Noskip
	If UCase(Left(part.Decal, 4)) = "DRIL" Then GoTo Noskip
	If part.Attributes("Value") = "SLOT" Then GoTo Noskip
	If UCase(Left(part.Decal, 6)) = "SOLDER" Then GoTo Noskip
	If UCase(Left(part.Decal, 3)) = "VIA" Then GoTo Noskip
	If UCase(Left(part.Decal, 3)) = "PAD" Or UCase(Left(part.Decal, 3)) = "MTG" Then GoTo Noskip 
	GoTo Skip5

Noskip:
  If Header5 = 1 Then GoTo Sh5
	Outcell "**** Top, Holes & Test-points"
  Print #1
  Linenum = Linenum + 1
  Header5 = 1
  Color7 = Linenum
Sh5:
	OutCell "No part"
	OutCell part.Name
	OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
	OutCell ActiveDocument.LayerName(part.layer)
	OutCell Format(part.IsSMD, "Yes/No")
	
	
	If UCase(part.Attributes("Value")) = "TP" Then OutCell part.Pins(1).Net.Name
 	Print #1
	Linenum = Linenum + 1
Skip5:
	Next part
'---------------------	
	'Bottom Holes, TP, 
	For Each part In ActiveDocument.Components
	If ActiveDocument.LayerName(part.layer) = L1NAME Then GoTo Skip6
	' Non Parts, 
	If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Skip6
	If UCase(Left(part.Decal, 3)) = "FID" Then GoTo Skip6
	If UCase(Left(part.Attributes("Value"), 4)) = "HOLE" Or UCase(Right(part.Attributes("Value"), 4)) = "HOLE" Then GoTo Noskip2
	If UCase(Left(part.Attributes("Value"), 2)) = "MH" Then GoTo Noskip2
	If UCase(Left(part.Decal, 1)) = "#" Then GoTo Noskip2  ' Mounting Hole
	If UCase(Left(part.Decal, 2)) = "TP" Or UCase(part.Attributes("Value")) = "TP" Then GoTo Noskip2 
	If part.Attributes("Value") = "TEST_POINT" Then GoTo Noskip2
	If UCase(Left(part.Decal, 4)) = "DRIL" Then GoTo Noskip2
	If part.Attributes("Value") = "SLOT" Then GoTo Noskip2
	If UCase(Left(part.Decal, 6)) = "SOLDER" Then GoTo Noskip2
	If UCase(Left(part.Decal, 3)) = "VIA" Then GoTo Noskip2
	If UCase(Left(part.Decal, 3)) = "PAD" Or UCase(Left(part.Decal, 3)) = "MTG" Then GoTo Noskip2 
	GoTo Skip6

Noskip2:
  If Header6 = 1 Then GoTo Sh6
  Outcell "**** Bottom, Holes & Test-points"
  Print #1
  Linenum = Linenum + 1
  Header6 = 1
  Color8 = Linenum
Sh6:
  OutCell "No part"
  OutCell part.Name
  OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX*-1, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
  OutCell ActiveDocument.LayerName(part.layer)
  OutCell Format(part.IsSMD, "Yes/No")
  If UCase(part.Attributes("Value")) = "TP" Then OutCell part.Pins(1).Net.Name
  Print #1
  Linenum = Linenum + 1
Skip6:
  Next part
'---------------------	
  'Top No populate, DNP 
  For Each part In ActiveDocument.Components
  If ActiveDocument.LayerName(part.layer) <> L1NAME Then GoTo Skip7
  ' Non Parts, 
  If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Noskip7
  GoTo Skip7
Noskip7:
  If Header7 = 1 Then GoTo Sh7
  Outcell "**** Top, Do not populate DNP"
  Print #1
  Linenum = Linenum + 1
  Header7 = 1
  Color9 = Linenum
Sh7:
  OutCell "No part"
  OutCell part.Name
  OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX*-1, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
  OutCell ActiveDocument.LayerName(part.layer)
  OutCell Format(part.IsSMD, "Yes/No")
  Print #1
  Linenum = Linenum + 1
Skip7:
  Next part

'-----------------------------------------------------
'Bottom No populate, DNP 
  For Each part In ActiveDocument.Components
  If ActiveDocument.LayerName(part.layer) = L1NAME Then GoTo Skip8
  If UCase(Left(part.Attributes("Value"),3)) = "DNP" Or UCase(Right(part.Attributes("Value"),3)) = "DNP" Or UCase(Left(part.Attributes("Value"),3)) = "DNI" Or UCase(Right(part.Attributes("Value"),3)) = "DNI" Then GoTo Noskip8
  GoTo Skip8
Noskip8:
  If Header8 = 1 Then GoTo Sh8
  Outcell "**** Bottom, Do not populate DNP"
  Print #1
  Linenum = Linenum + 1
  Header8 = 1
  Color10 = Linenum
Sh8:
  OutCell "No part"
  OutCell part.Name
  OutCell part.Decal
  If part.Attributes("Value") Is Nothing Then OutCell "" Else OutCell part.Attributes("Value")
  OutCell Format(part.PositionX*-1, "0.000")
  OutCell Format(part.PositionY, "0.000")
  OutCell part.Orientation
	OutCell ActiveDocument.LayerName(part.layer)
	OutCell Format(part.IsSMD, "Yes/No")
	Print #1
	Linenum = Linenum + 1
Skip8:
	Next part
  OutCell "    **** End ****"
  Print #1
  Linenum = Linenum + 1
  Color11 = Linenum

'-----------------------------------------------------
  Close #1
  ExportToExcel
  ActiveDocument.unit = currentUnit ' Set units back to original
  UnlockServer
  End Sub

Sub ExportToExcel
	FillClipboard
	Dim xl As Object
	On Error Resume Next
	Set xl =  GetObject(,"Excel.Application")
	On Error GoTo ExcelError	' Enable error trapping.
	If xl Is Nothing Then
	Set xl =  CreateObject("Excel.Application")
	End If
	xl.Visible = True
	xl.Workbooks.Add
	xl.ActiveSheet.Paste
	xl.Range("A1:A2").Font.Bold = True
    xl.Range("A:D").NumberFormat = "@"
    xl.Range("E:F").NumberFormat = "0.00"             '"[=0]0;0.##"
    xl.Range("G:G").NumberFormat = General
    xl.Range("A3").NumberFormat = "[$-1046]mmm/dd/yyyy" 
    xl.Range("E:G").HorizontalAlignment = -4152 'Right
    xl.Range("A:J").VerticalAlignment = -4160 'Top
	xl.ActiveSheet.UsedRange.Columns.AutoFit
	xl.Range("A:A").ColumnWidth = 12
	xl.Range("B:B").ColumnWidth = 7
    xl.Range("D:D").ColumnWidth = 12
    xl.Range("J:J").ColumnWidth = 6
    xl.Range("A1:A1").Font.Color = RGB(255, 0, 0)
    xl.Range("A5:I5").Interior.Color = RGB(153, 207, 234)
   
	xx = "A" + Color1 + ":A" + Color1
    If Color1 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
	xx = "A" + Color2 + ":A" + Color2
    If Color2 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color3 + ":A" + Color3
    If Color3 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color4 + ":A" + Color4
    If Color4 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color5 + ":A" + Color5
    If Color5 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color6 + ":A" + Color6
    If Color6 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color7 + ":A" + Color7
    If Color7 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color8 + ":A" + Color8
    If Color8 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255)
    xx = "A" + Color9 + ":A" + Color9
    If Color9 <> 0 Then xl.Range(xx).Font.Color = RGB(255, 0, 0)
    xx = "A" + Color10 + ":A" + Color10
    If Color10 <> 0 Then xl.Range(xx).Font.Color = RGB(255, 0, 0)
    xx = "A" + Color11 + ":A" + Color11
    If Color11 <> 0 Then xl.Range(xx).Font.Color = RGB(0, 0, 255) 
    If Color11 <> 0 Then xl.Range(xx).Font.Bold = True
    xl.Range("A4").Select
  
  Lenfn = Len(ActiveDocument.FullName)
  Bom = Left((ActiveDocument.FullName), Lenfn -4) + "_BOM"
  Clipboard Bom      ' Fill windows clipboard with file path & name for "Save As"
  On Error GoTo 0 ' Disable error trapping. 
Exit Sub    

ExcelError:
	MsgBox Err.Description, vbExclamation, "Error Running Excel"
	On Error GoTo 0 ' Disable error trapping.    
	Exit Sub
End Sub

Sub OutCell (txt As String)
	Print #1, txt; vbTab;
End Sub

Sub FillClipboard
	' Load whole file to string variable    
	tempFile = DefaultFilePath & "\temp.txt"
	Open tempFile  For Input As #1
	L = LOF(1)
	AllData$ = Input$(L,1)
	Close #1
	'Copy whole data to clipboard
	Clipboard AllData$ 
	Kill tempFile
End Sub
Function IsSMDByPin1(obj As Object) As Boolean
  If obj.Pins.Count = 0 Then 
  IsSMDByPin1=True
  GoTo Nopin
End If
If obj.Pins(1).DrillSize=0 Then IsSMDByPin1=True  ' Every part must have a pin #1.
Nopin:
End Function
